/*
 * Copyright (C) 2017 University of Chicago.
 * See COPYRIGHT notice in top-level directory.
 *
 */

#ifndef __APXC_LOG_FORMAT_H
#define __APXC_LOG_FORMAT_H

/* current AutoPerf Cray XC log format version */
#define APXC_VER 1

#define APXC_MAGIC ('A'*0x100000000000000+\
                            'U'*0x1000000000000+\
                            'T'*0x10000000000+\
                            'O'*0x100000000+\
                            'P'*0x1000000+\
                            'E'*0x10000+\
                            'R'*0x100+\
                            'F'*0x1)

#define APXC_PERF_COUNTERS \
    /* PAPI counters */\
    X(AR_RTR_0_0_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_0_0_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_0_0_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_0_0_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_0_0_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_0_0_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_0_0_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_0_0_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_0_0_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_0_1_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_0_1_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_0_1_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_0_1_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_0_1_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_0_1_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_0_1_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_0_1_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_0_1_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_0_2_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_0_2_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_0_2_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_0_2_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_0_2_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_0_2_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_0_2_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_0_2_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_0_2_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_0_3_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_0_3_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_0_3_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_0_3_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_0_3_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_0_3_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_0_3_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_0_3_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_0_3_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_0_4_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_0_4_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_0_4_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_0_4_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_0_4_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_0_4_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_0_4_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_0_4_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_0_4_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_0_5_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_0_5_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_0_5_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_0_5_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_0_5_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_0_5_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_0_5_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_0_5_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_0_5_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_0_6_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_0_6_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_0_6_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_0_6_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_0_6_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_0_6_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_0_6_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_0_6_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_0_6_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_0_7_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_0_7_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_0_7_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_0_7_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_0_7_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_0_7_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_0_7_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_0_7_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_0_7_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_1_0_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_1_0_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_1_0_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_1_0_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_1_0_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_1_0_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_1_0_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_1_0_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_1_0_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_1_1_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_1_1_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_1_1_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_1_1_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_1_1_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_1_1_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_1_1_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_1_1_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_1_1_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_1_2_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_1_2_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_1_2_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_1_2_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_1_2_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_1_2_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_1_2_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_1_2_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_1_2_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_1_3_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_1_3_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_1_3_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_1_3_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_1_3_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_1_3_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_1_3_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_1_3_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_1_3_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_1_4_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_1_4_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_1_4_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_1_4_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_1_4_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_1_4_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_1_4_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_1_4_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_1_4_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_1_5_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_1_5_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_1_5_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_1_5_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_1_5_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_1_5_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_1_5_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_1_5_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_1_5_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_1_6_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_1_6_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_1_6_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_1_6_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_1_6_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_1_6_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_1_6_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_1_6_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_1_6_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_1_7_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_1_7_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_1_7_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_1_7_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_1_7_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_1_7_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_1_7_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_1_7_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_1_7_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_2_0_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_2_0_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_2_0_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_2_0_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_2_0_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_2_0_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_2_0_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_2_0_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_2_0_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_2_1_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_2_1_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_2_1_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_2_1_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_2_1_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_2_1_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_2_1_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_2_1_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_2_1_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_2_2_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_2_2_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_2_2_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_2_2_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_2_2_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_2_2_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_2_2_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_2_2_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_2_2_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_2_3_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_2_3_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_2_3_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_2_3_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_2_3_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_2_3_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_2_3_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_2_3_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_2_3_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_2_4_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_2_4_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_2_4_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_2_4_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_2_4_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_2_4_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_2_4_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_2_4_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_2_4_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_2_5_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_2_5_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_2_5_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_2_5_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_2_5_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_2_5_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_2_5_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_2_5_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_2_5_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_2_6_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_2_6_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_2_6_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_2_6_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_2_6_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_2_6_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_2_6_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_2_6_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_2_6_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_2_7_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_2_7_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_2_7_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_2_7_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_2_7_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_2_7_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_2_7_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_2_7_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_2_7_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_3_0_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_3_0_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_3_0_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_3_0_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_3_0_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_3_0_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_3_0_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_3_0_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_3_0_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_3_1_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_3_1_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_3_1_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_3_1_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_3_1_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_3_1_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_3_1_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_3_1_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_3_1_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_3_2_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_3_2_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_3_2_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_3_2_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_3_2_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_3_2_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_3_2_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_3_2_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_3_2_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_3_3_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_3_3_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_3_3_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_3_3_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_3_3_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_3_3_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_3_3_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_3_3_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_3_3_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_3_4_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_3_4_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_3_4_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_3_4_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_3_4_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_3_4_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_3_4_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_3_4_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_3_4_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_3_5_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_3_5_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_3_5_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_3_5_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_3_5_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_3_5_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_3_5_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_3_5_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_3_5_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_3_6_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_3_6_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_3_6_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_3_6_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_3_6_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_3_6_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_3_6_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_3_6_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_3_6_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_3_7_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_3_7_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_3_7_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_3_7_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_3_7_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_3_7_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_3_7_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_3_7_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_3_7_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_4_0_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_4_0_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_4_0_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_4_0_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_4_0_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_4_0_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_4_0_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_4_0_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_4_0_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_4_1_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_4_1_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_4_1_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_4_1_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_4_1_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_4_1_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_4_1_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_4_1_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_4_1_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_4_2_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_4_2_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_4_2_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_4_2_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_4_2_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_4_2_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_4_2_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_4_2_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_4_2_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_4_3_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_4_3_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_4_3_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_4_3_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_4_3_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_4_3_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_4_3_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_4_3_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_4_3_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_4_4_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_4_4_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_4_4_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_4_4_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_4_4_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_4_4_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_4_4_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_4_4_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_4_4_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_4_5_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_4_5_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_4_5_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_4_5_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_4_5_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_4_5_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_4_5_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_4_5_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_4_5_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_4_6_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_4_6_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_4_6_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_4_6_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_4_6_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_4_6_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_4_6_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_4_6_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_4_6_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_4_7_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_4_7_INQ_PRF_INCOMING_FLIT_VC1) \
    X(AR_RTR_4_7_INQ_PRF_INCOMING_FLIT_VC2) \
    X(AR_RTR_4_7_INQ_PRF_INCOMING_FLIT_VC3) \
    X(AR_RTR_4_7_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_4_7_INQ_PRF_INCOMING_FLIT_VC5) \
    X(AR_RTR_4_7_INQ_PRF_INCOMING_FLIT_VC6) \
    X(AR_RTR_4_7_INQ_PRF_INCOMING_FLIT_VC7) \
    X(AR_RTR_4_7_INQ_PRF_ROWBUS_STALL_CNT) \
    X(AR_RTR_PT_5_0_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_PT_5_0_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_PT_5_0_INQ_PRF_REQ_ROWBUS_STALL_CNT) \
    X(AR_RTR_PT_5_0_INQ_PRF_RSP_ROWBUS_STALL_CNT) \
    X(AR_RTR_PT_5_1_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_PT_5_1_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_PT_5_1_INQ_PRF_REQ_ROWBUS_STALL_CNT) \
    X(AR_RTR_PT_5_1_INQ_PRF_RSP_ROWBUS_STALL_CNT) \
    X(AR_RTR_PT_5_2_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_PT_5_2_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_PT_5_2_INQ_PRF_REQ_ROWBUS_STALL_CNT) \
    X(AR_RTR_PT_5_2_INQ_PRF_RSP_ROWBUS_STALL_CNT) \
    X(AR_RTR_PT_5_3_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_PT_5_3_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_PT_5_3_INQ_PRF_REQ_ROWBUS_STALL_CNT) \
    X(AR_RTR_PT_5_3_INQ_PRF_RSP_ROWBUS_STALL_CNT) \
    X(AR_RTR_PT_5_4_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_PT_5_4_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_PT_5_4_INQ_PRF_REQ_ROWBUS_STALL_CNT) \
    X(AR_RTR_PT_5_4_INQ_PRF_RSP_ROWBUS_STALL_CNT) \
    X(AR_RTR_PT_5_5_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_PT_5_5_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_PT_5_5_INQ_PRF_REQ_ROWBUS_STALL_CNT) \
    X(AR_RTR_PT_5_5_INQ_PRF_RSP_ROWBUS_STALL_CNT) \
    X(AR_RTR_PT_5_6_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_PT_5_6_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_PT_5_6_INQ_PRF_REQ_ROWBUS_STALL_CNT) \
    X(AR_RTR_PT_5_6_INQ_PRF_RSP_ROWBUS_STALL_CNT) \
    X(AR_RTR_PT_5_7_INQ_PRF_INCOMING_FLIT_VC0) \
    X(AR_RTR_PT_5_7_INQ_PRF_INCOMING_FLIT_VC4) \
    X(AR_RTR_PT_5_7_INQ_PRF_REQ_ROWBUS_STALL_CNT) \
    X(AR_RTR_PT_5_7_INQ_PRF_RSP_ROWBUS_STALL_CNT) \
    /* end of counters */\
    Z(APXC_NUM_INDICES)

#define APXC_MEMORY_MODES \
    X(MM_UNKNOWN) \
    X(MM_FLAT) \
    X(MM_EQUAL) \
    X(MM_SPLIT) \
    X(MM_CACHE) \
    Z(MM_NUM_INDICES) 

#define APXC_CLUSTER_MODES \
    X(CM_UNKNOWN) \
    X(CM_ALL2ALL) \
    X(CM_QUAD) \
    X(CM_HEMI) \
    X(CM_SNC4) \
    X(CM_SNC2) \
    Z(CM_NUM_INDICIES)

#define X(a) a,
#define Z(a) a
/* integer counters for the "APXC" example module */
enum darshan_apxc_perf_indices
{
    APXC_PERF_COUNTERS
};

enum apxc_memory_modes
{
    APXC_MEMORY_MODES
};

enum apxc_cluster_modes
{
    APXC_CLUSTER_MODES
};
#undef Z
#undef X

/* the darshan_apxc_router_record structure encompasses the data/counters
 * which would actually be logged to file by Darshan for the AP Cray XC
 * module. This example implementation logs the following data for each
 * record:
 *      - a darshan_base_record structure, which contains the record id & rank
 *      - integer I/O counters 
 *      - floating point I/O counters 
 */
struct darshan_apxc_perf_record
{
    struct darshan_base_record base_rec;
    int64_t group;
    int64_t chassis;
    int64_t blade;
    int64_t node;
    uint64_t counters[APXC_NUM_INDICES];
};

struct darshan_apxc_header_record
{
    struct darshan_base_record base_rec;
    int64_t magic;
    int64_t nblades;
    int64_t nchassis;
    int64_t ngroups;
    int64_t memory_mode;
    int64_t cluster_mode;
    uint64_t appid;
};

#endif /* __APXC_LOG_FORMAT_H */
